# coding=utf8

import json

from context import get_json_value


class TagFilter(object):

    def __init__(self, tagfilter_def):
        self.all = []
        self.any = []
        self.no = []

        try:
            _all = get_json_value(tagfilter_def, 'all')
            if isinstance(_all, list) and len(_all) > 0:
                self.all = _all
            _any = get_json_value(tagfilter_def, 'any')
            if isinstance(_any, list) and len(_any) > 0:
                self.any = _any
            _not = get_json_value(tagfilter_def, 'not')
            if isinstance(_not, list) and len(_not) > 0:
                self.no = _not
        except:
            pass

    def to_dict(self):
        d = {}
        if len(self.all) > 0:
            d['all'] = self.all
        if len(self.any) > 0:
            d['any'] = self.any
        if len(self.no) > 0:
            d['not'] = self.no
        return d
